<template>
  <v-row dense>
    <GCol cols="12">
      <GTextField
        v-model="value._attr.refType"
        i18n="dcc.common.attributes.refType"
        attr-ref-type
      />
    </GCol>
    <GCol cols="12">
      <DccLocalizedTextBlock
        v-model="value.name"
        i18n="dcc.common.usedMethodListType.name"
        validate="required"
      />
    </GCol>
    <GCol cols="12">
      <div v-if="value.description" class="mt-2">
        <RichContent
          v-model="value.description"
          i18n="dcc.common.richContentType.description.title"
          optional
          level="second"
          @delete="deleteRichContent"
        />
      </div>
    </GCol>
    <GCol cols="12" md="6">
      <DccArrayWrapper
        v-model="value.norm"
        :component="XmlTextField"
        i18n="dcc.common.usedMethodListType.norm"
        validate="notEmptyStringType"
      />
    </GCol>
    <GCol cols="12" md="6">
      <DccArrayWrapper
        v-model="value.reference"
        :component="XmlTextField"
        i18n="dcc.common.usedMethodListType.reference"
        validate="notEmptyStringType"
      />
    </GCol>
  </v-row>
</template>

<script>
import { RichContentType } from "@d-ptb/dcc-js";
import RichContent from "@/components/DCC/Common/RichContent";
import GCol from "@/components/App/Common/GCol";
import { insertIf } from "~/assets/util/general";
import GTextField from "~/components/App/Form/gTextField";
import DccArrayWrapper from "~/components/App/Form/XML/DccArrayWrapper.vue";
import DccLocalizedTextBlock from "~/components/App/Form/XML/DccLocalizedTextBlock";
import XmlTextField from "~/components/App/Form/XML/XmlTextField";
export default {
  name: "UsedMethod",
  components: {
    DccLocalizedTextBlock,
    DccArrayWrapper,
    GTextField,
    GCol,
    RichContent,
  },
  props: {
    value: Object,
    updateAvailableElements: Function,
  },
  data() {
    return {
      XmlTextField,
    };
  },
  computed: {
    availableElements() {
      return [
        {
          text: this.$t(`dcc.common.richContentType.description.title`),
          value: "description",
          addElement: () => this.addElement("description"),
        },
      ].filter((x) => !this.blacklist.includes(x.value));
    },
    blacklist() {
      return [...insertIf(this.value.description, "description")];
    },
  },
  watch: {
    availableElements: {
      handler() {
        this.updateAvailableElements(this.availableElements);
      },
      immediate: true,
      deep: true,
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "description":
          this.$set(this.value, "description", new RichContentType());
          break;
      }
    },
    deleteRichContent() {
      confirm(
        this.$t("dcc.common.richContentType.description.confirmRemove")
      ) && this.$delete(this.value, "description");
    },
  },
};
</script>
